#import "BTClient.h"

/// Category for offline-only BTClient methods
///
/// Do not use this in production.
///
/// @see BTOfflineModeURLProtocol
@interface BTClient (Offline)

/// Obtain a client token only for use in offline development and testing. It looks as if
/// it were generated by a server-side client library, but it causes the iOS code to run
/// offline mode with no network dependencies and faked behavior.
///
/// @param configuration Optional additional client token parameters (useful for extensions to
///        `BTClient` that rely on the contents of the client token)
///
/// @return client token string
+ (NSString *)offlineTestClientTokenWithAdditionalParameters:(NSDictionary *)configuration DEPRECATED_MSG_ATTRIBUTE("Offline BTClient is no longer supported. Please use a real client token by on your server. (See https://developers.braintreepayments.com/ios/sdk/overview/generate-client-token)");

@end
