#import <Foundation/Foundation.h>
#import "BTErrors.h"

@class BTAPIResponseParser;

extern NSString *const BTClientTokenKeyVersion;
extern NSString *const BTClientTokenKeyAuthorizationFingerprint;
extern NSString *const BTClientTokenKeyConfigURL;

@interface BTClientToken : NSObject <NSCoding, NSCopying>

/// Parser to digest the token data
@property (nonatomic, readonly, strong) BTAPIResponseParser *clientTokenParser;
/// The extracted authorization fingerprint
@property (nonatomic, readonly, copy) NSString *authorizationFingerprint;
/// The extracted configURL
@property (nonatomic, readonly, strong) NSURL *configURL;

#pragma mark -

//// Initialize a client token with a client token string generated by a Braintree Server SDK.
- (instancetype)initWithClientTokenString:(NSString *)JSONString error:(NSError **)error NS_DESIGNATED_INITIALIZER;

@end
